//+------------------------------------------------------------------+
//|                                     Fractals - adjustable period |
//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  3
#property indicator_color1   clrBlue
#property indicator_color2   clrRed
#property indicator_color3   clrGray
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;    // Time frame
extern string             ForSymbol       = "";             // Symbol to use (leave empty for current symbol)
extern int                FractalPeriod   = 25;
extern ENUM_APPLIED_PRICE PriceHigh       = PRICE_HIGH;
extern ENUM_APPLIED_PRICE PriceLow        = PRICE_LOW;



double UpH[],DnH[],NuH[],UpperBuffer[],LowerBuffer[],trend[],count[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",FractalPeriod,PriceHigh,PriceLow,_buff,_ind)

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{ 
   IndicatorBuffers(7);
   SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,NuH); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,UpperBuffer); 
   SetIndexBuffer(4,LowerBuffer);
   SetIndexBuffer(5,trend);
   SetIndexBuffer(6,count);
   
   IndicatorSetDouble(INDICATOR_MINIMUM,0);
   IndicatorSetDouble(INDICATOR_MAXIMUM,1);
   
   indicatorFileName = WindowExpertName();
   TimeFrame         = fmax(TimeFrame,_Period);
   ForSymbol         = (ForSymbol=="") ? _Symbol : ForSymbol;  
   
   IndicatorSetString(INDICATOR_SHORTNAME,timeFrameToString(TimeFrame)+" "+ForSymbol+" fractal channel histo ("+(string)FractalPeriod+")");    
return(0);
}
int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      limit=MathMin(MathMax(Bars-counted_bars,FractalPeriod),Bars-1); count[0] = limit;
      if (TimeFrame!=_Period || ForSymbol!=_Symbol)
      {
         limit = (int)fmax(limit,fmin(Bars-1,_mtfCall(6,0)*TimeFrame/_Period));
         for(i=limit; i>=0; i--)
         {
                  int y = iBarShift(ForSymbol,TimeFrame,Time[i]);
                     UpH[i] = _mtfCall(0,y);
                     DnH[i] = _mtfCall(1,y);
                     NuH[i] = _mtfCall(2,y);
         }  
   return(0);
   }            
   

   //
   //
   //
   //
   //

     int half = FractalPeriod/2;
     for(i=limit; i>=0; i--)
     {
         bool   found     = true;
         double compareTo = iMA(ForSymbol,0,1,0,MODE_SMA,PriceHigh,i);
         for (int k=1;k<=half;k++)
            {
               if ((i+k)<Bars && iMA(ForSymbol,0,1,0,MODE_SMA,PriceHigh,i+k)> compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(ForSymbol,0,1,0,MODE_SMA,PriceHigh,i-k)>=compareTo) { found=false; break; }
            }
         if (found) UpperBuffer[i]=iMA(ForSymbol,0,1,0,MODE_SMA,PriceHigh,i);
         else       UpperBuffer[i]=UpperBuffer[i+1];

         //
         //
         //
         //
         //
      
         found     = true;
         compareTo = iMA(ForSymbol,0,1,0,MODE_SMA,PriceLow,i);
         for (k=1;k<=half;k++)
            {
               if ((i+k)<Bars && iMA(ForSymbol,0,1,0,MODE_SMA,PriceLow,i+k)< compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(ForSymbol,0,1,0,MODE_SMA,PriceLow,i-k)<=compareTo) { found=false; break; }
            }
         if (found) LowerBuffer[i]=iMA(ForSymbol,0,1,0,MODE_SMA,PriceLow,i);  
         else       LowerBuffer[i]=LowerBuffer[i+1];
         
         trend[i] = trend[i+1];;
         if (Close[i]>UpperBuffer[i])                          trend[i] = 1;
         if (Close[i]<LowerBuffer[i])                          trend[i] =-1;
         if (Close[i]<UpperBuffer[i]&&Close[i]>LowerBuffer[i]) trend[i] = 0;
         UpH[i]  = (trend[i] == 1) ? 1 : EMPTY_VALUE;
         DnH[i]  = (trend[i] ==-1) ? 1 : EMPTY_VALUE;  
         NuH[i]  = (trend[i] == 0) ? 1 : EMPTY_VALUE;     
   }
return(0);
}

//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}